#include <basic.h>
#include <bstdio.h>
#include <new>
#include "ktext.h"
#include "record.h"
#include "compiler.h"
#include "gcommon.h"
#include "r_obj.h"

int SubC::execute()
{
  compiler->execute();
  return 0;
}

int SubC::compile()
{
  if (src_lnk == NULL){
    printf("SubC::not set the link pointer. \n");
    return -1;
  }
	
  RealObject *src_obj;
  if ((src_obj = new(std::nothrow) RealObject(src_lnk)) == NULL){
    printf("SubC::RealObject can't new.");
    return -1;
  }
  compiler->compile_init();
  compiler->compile(src_obj, MAIN_SRC);
  compiler->compile_end();

  delete src_obj;
  return 0;
}

int SubC::set_cpl()
{
  if (compiler != NULL){
    delete compiler;
  }
  if ((compiler = new(std::nothrow) GProgram()) == NULL){
    printf("SubC::GProgram can't new.");
    return -1;
  }
  return 0;
}

SubC::SubC(LINK* lnk)
{
  compiler = NULL;
  src_lnk = lnk;
  set_cpl();
}

SubC::SubC()
{
  compiler = NULL;
  src_lnk = NULL;
}


